Up

# NSURLSession documentation

### Authors

Generated by Debian

### Contents -

1. Software documentation for the NSURLSession class
2. Software documentation for the NSURLSessionConfiguration class
3. Software documentation for the NSURLSessionDataTask class
4. Software documentation for the NSURLSessionDownloadTask class
5. Software documentation for the NSURLSessionStreamTask class
6. Software documentation for the NSURLSessionTask class
7. Software documentation for the NSURLSessionUploadTask class
8. Software documentation for the NSURLSessionDataDelegate protocol
9. Software documentation for the NSURLSessionDelegate protocol
10. Software documentation for the NSURLSessionDownloadDelegate protocol
11. Software documentation for the NSURLSessionTaskDelegate protocol

# Software documentation for the NSURLSession class

## NSURLSession : NSObject

> Declared in:
>   Foundation/NSURLSession.h

Availability: Not in OpenStep/MacOS-X
NSURLSession is a replacement API for NSURLConnection. It provides options that affect the policy of, and various aspects of the mechanism by which NSURLRequest objects are retrieved from the network.
An NSURLSession may be bound to a delegate object. The delegate is invoked for certain events during the lifetime of a session. NSURLSession instances are threadsafe. An NSURLSession creates NSURLSessionTask objects which represent the action of a resource being loaded. NSURLSessionTask objects are always created in a suspended state and must be sent the -resume message before they will execute. Subclasses of NSURLSessionTask are used to syntactically differentiate between data and file downloads. An NSURLSessionDataTask receives the resource as a series of calls to the URLSession:dataTask:didReceiveData: delegate method. This is type of task most commonly associated with retrieving objects for immediate parsing by the consumer.

Instance Variables
Method summary

- +sessionWithConfiguration:delegate:delegateQueue:
- -configuration
- -dataTaskWithRequest:
- -dataTaskWithURL:
- -delegate
- -delegateQueue
- -downloadTaskWithRequest:
- -downloadTaskWithURL:
- -finishTasksAndInvalidate
- -invalidateAndCancel
- -sessionDescription
- -setSessionDescription:

### sessionWithConfiguration: delegate: delegateQueue:

+ (NSURLSession*) sessionWithConfiguration: (NSURLSessionConfiguration*)configuration delegate: (id<NSURLSessionDelegate>)delegate delegateQueue: (NSOperationQueue*)queue;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### configuration

- (NSURLSessionConfiguration*) configuration;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### dataTaskWithRequest:

- (NSURLSessionDataTask*) dataTaskWithRequest: (NSURLRequest*)request;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### dataTaskWithURL:

- (NSURLSessionDataTask*) dataTaskWithURL: (NSURL*)url;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### delegate

- (id<NSURLSessionDelegate>) delegate;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### delegateQueue

- (NSOperationQueue*) delegateQueue;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### downloadTaskWithRequest:

- (NSURLSessionDownloadTask*) downloadTaskWithRequest: (NSURLRequest*)request;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### downloadTaskWithURL:

- (NSURLSessionDownloadTask*) downloadTaskWithURL: (NSURL*)url;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### finishTasksAndInvalidate

- (void) finishTasksAndInvalidate;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### invalidateAndCancel

- (void) invalidateAndCancel;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### sessionDescription

- (NSString*) sessionDescription;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setSessionDescription:

- (void) setSessionDescription: (NSString*)sessionDescription;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

## Instance Variables for NSURLSession Class

### _configuration

@protected NSURLSessionConfiguration* _configuration;
Availability: Not in OpenStep/MacOS-X
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _delegate

@protected id<NSURLSessionDelegate> _delegate;
Availability: Not in OpenStep/MacOS-X
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _delegateQueue

@protected NSOperationQueue* _delegateQueue;
Availability: Not in OpenStep/MacOS-X
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _multiHandle

@protected GSMultiHandle* _multiHandle;
Availability: Not in OpenStep/MacOS-X
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _sessionDescription

@protected NSString* _sessionDescription;
Availability: Not in OpenStep/MacOS-X
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

# Software documentation for the NSURLSessionConfiguration class

## NSURLSessionConfiguration : NSObject

> Declared in:
>   Foundation/NSURLSession.h

> Conforms to:
>   NSCopying

Availability: Not in OpenStep/MacOS-X
Description forthcoming.

Instance Variables
Method summary

- -HTTPAdditionalHeaders
- -HTTPCookieAcceptPolicy
- -HTTPCookieStorage
- -HTTPMaximumConnectionLifetime
- -HTTPMaximumConnectionsPerHost
- -HTTPShouldSetCookies
- -HTTPShouldUsePipelining
- -URLCache
- -URLCredentialStorage
- -configureRequest:
- -protocolClasses
- -requestCachePolicy
- -setHTTPAdditionalHeaders:
- -setHTTPCookieAcceptPolicy:
- -setHTTPCookieStorage:
- -setHTTPMaximumConnectionLifetime:
- -setHTTPMaximumConnectionsPerHost:
- -setHTTPShouldSetCookies:
- -setHTTPShouldUsePipelining:
- -setRequestCachePolicy:
- -setURLCache:
- -setURLCredentialStorage:

### HTTPAdditionalHeaders

- (NSDictionary*) HTTPAdditionalHeaders;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### HTTPCookieAcceptPolicy

- (NSHTTPCookieAcceptPolicy) HTTPCookieAcceptPolicy;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### HTTPCookieStorage

- (NSHTTPCookieStorage*) HTTPCookieStorage;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### HTTPMaximumConnectionLifetime

- (NSInteger) HTTPMaximumConnectionLifetime;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### HTTPMaximumConnectionsPerHost

- (NSInteger) HTTPMaximumConnectionsPerHost;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### HTTPShouldSetCookies

- (BOOL) HTTPShouldSetCookies;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### HTTPShouldUsePipelining

- (BOOL) HTTPShouldUsePipelining;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### URLCache

- (NSURLCache*) URLCache;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### URLCredentialStorage

- (NSURLCredentialStorage*) URLCredentialStorage;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### configureRequest:

- (NSURLRequest*) configureRequest: (NSURLRequest*)request;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### protocolClasses

- (NSArray*) protocolClasses;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### requestCachePolicy

- (NSURLRequestCachePolicy) requestCachePolicy;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setHTTPAdditionalHeaders:

- (void) setHTTPAdditionalHeaders: (NSDictionary*)headers;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setHTTPCookieAcceptPolicy:

- (void) setHTTPCookieAcceptPolicy: (NSHTTPCookieAcceptPolicy)policy;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setHTTPCookieStorage:

- (void) setHTTPCookieStorage: (NSHTTPCookieStorage*)storage;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setHTTPMaximumConnectionLifetime:

- (void) setHTTPMaximumConnectionLifetime: (NSInteger)n;
Availability: Not in OpenStep/MacOS-X
Permits a session to be configured so that older connections are reused. A value of zero or less uses the default behavior where connections are reused as long as they are not older than 118 seconds, which is reasonable for the vast majority if situations.

### setHTTPMaximumConnectionsPerHost:

- (void) setHTTPMaximumConnectionsPerHost: (NSInteger)n;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setHTTPShouldSetCookies:

- (void) setHTTPShouldSetCookies: (BOOL)flag;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setHTTPShouldUsePipelining:

- (void) setHTTPShouldUsePipelining: (BOOL)flag;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setRequestCachePolicy:

- (void) setRequestCachePolicy: (NSURLRequestCachePolicy)policy;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setURLCache:

- (void) setURLCache: (NSURLCache*)cache;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setURLCredentialStorage:

- (void) setURLCredentialStorage: (NSURLCredentialStorage*)storage;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

## Instance Variables for NSURLSessionConfiguration Class

### _HTTPAdditionalHeaders

@protected NSDictionary* _HTTPAdditionalHeaders;
Availability: Not in OpenStep/MacOS-X
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _HTTPCookieAcceptPolicy

@protected NSHTTPCookieAcceptPolicy _HTTPCookieAcceptPolicy;
Availability: Not in OpenStep/MacOS-X
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _HTTPCookieStorage

@protected NSHTTPCookieStorage* _HTTPCookieStorage;
Availability: Not in OpenStep/MacOS-X
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _HTTPMaximumConnectionLifetime

@protected NSInteger _HTTPMaximumConnectionLifetime;
Availability: Not in OpenStep/MacOS-X
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _HTTPMaximumConnectionsPerHost

@protected NSInteger _HTTPMaximumConnectionsPerHost;
Availability: Not in OpenStep/MacOS-X
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _HTTPShouldSetCookies

@protected BOOL _HTTPShouldSetCookies;
Availability: Not in OpenStep/MacOS-X
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _HTTPShouldUsePipelining

@protected BOOL _HTTPShouldUsePipelining;
Availability: Not in OpenStep/MacOS-X
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _URLCache

@protected NSURLCache* _URLCache;
Availability: Not in OpenStep/MacOS-X
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _URLCredentialStorage

@protected NSURLCredentialStorage* _URLCredentialStorage;
Availability: Not in OpenStep/MacOS-X
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _protocolClasses

@protected NSArray* _protocolClasses;
Availability: Not in OpenStep/MacOS-X
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _requestCachePolicy

@protected NSURLRequestCachePolicy _requestCachePolicy;
Availability: Not in OpenStep/MacOS-X
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

# Software documentation for the NSURLSessionDataTask class

## NSURLSessionDataTask : NSURLSessionTask

> Declared in:
>   Foundation/NSURLSession.h

Availability: Not in OpenStep/MacOS-X
Description forthcoming.

# Software documentation for the NSURLSessionDownloadTask class

## NSURLSessionDownloadTask : NSURLSessionTask

> Declared in:
>   Foundation/NSURLSession.h

Availability: Not in OpenStep/MacOS-X
Description forthcoming.

# Software documentation for the NSURLSessionStreamTask class

## NSURLSessionStreamTask : NSURLSessionTask

> Declared in:
>   Foundation/NSURLSession.h

Availability: Not in OpenStep/MacOS-X
Description forthcoming.

# Software documentation for the NSURLSessionTask class

## NSURLSessionTask : NSObject

> Declared in:
>   Foundation/NSURLSession.h

> Conforms to:
>   NSCopying

Availability: Not in OpenStep/MacOS-X
Description forthcoming.

Instance Variables
Method summary

- -cancel
- -countOfBytesExpectedToReceive
- -countOfBytesExpectedToSend
- -countOfBytesReceived
- -countOfBytesSent
- -currentRequest
- -error
- -originalRequest
- -response
- -resume
- -session
- -setResponse:
- -setTaskDescription:
- -state
- -suspend
- -taskDescription
- -taskIdentifier

### cancel

- (void) cancel;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### countOfBytesExpectedToReceive

- (int64_t) countOfBytesExpectedToReceive;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### countOfBytesExpectedToSend

- (int64_t) countOfBytesExpectedToSend;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### countOfBytesReceived

- (int64_t) countOfBytesReceived;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### countOfBytesSent

- (int64_t) countOfBytesSent;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### currentRequest

- (NSURLRequest*) currentRequest;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### error

- (NSError*) error;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### originalRequest

- (NSURLRequest*) originalRequest;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### response

- (NSURLResponse*) response;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### resume

- (void) resume;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### session

- (NSURLSession*) session;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setResponse:

- (void) setResponse: (NSURLResponse*)response;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### setTaskDescription:

- (void) setTaskDescription: (NSString*)taskDescription;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### state

- (NSURLSessionTaskState) state;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### suspend

- (void) suspend;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### taskDescription

- (NSString*) taskDescription;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### taskIdentifier

- (NSUInteger) taskIdentifier;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

## Instance Variables for NSURLSessionTask Class

### _countOfBytesExpectedToReceive

@protected int64_t _countOfBytesExpectedToReceive;
Availability: Not in OpenStep/MacOS-X
number of byte bytes we expect to receive, usually derived from the Content-Length header of an HTTP response.
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _countOfBytesExpectedToSend

@protected int64_t _countOfBytesExpectedToSend;
Availability: Not in OpenStep/MacOS-X
number of body bytes we expect to send, derived from the Content-Length of the HTTP request
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _countOfBytesReceived

@protected int64_t _countOfBytesReceived;
Availability: Not in OpenStep/MacOS-X
number of body bytes already received
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _countOfBytesSent

@protected int64_t _countOfBytesSent;
Availability: Not in OpenStep/MacOS-X
number of body bytes already sent
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _currentRequest

@protected NSURLRequest* _currentRequest;
Availability: Not in OpenStep/MacOS-X
The request this task is currently handling. This may differ from originalRequest due to http server redirection
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _error

@protected NSError* _error;
Availability: Not in OpenStep/MacOS-X
The error, if any, delivered via -URLSession:task:didCompleteWithError: This is `nil` until an error has occured.
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _knownBody

@protected GSURLSessionTaskBody* _knownBody;
Availability: Not in OpenStep/MacOS-X
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _originalRequest

@protected NSURLRequest* _originalRequest;
Availability: Not in OpenStep/MacOS-X
The request this task was created to handle.
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _response

@protected NSURLResponse* _response;
Availability: Not in OpenStep/MacOS-X
The response to the current request, which may be `nil` if no response has been received
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _state

@protected NSURLSessionTaskState _state;
Availability: Not in OpenStep/MacOS-X
The current state of the task within the session.
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _suspendCount

@protected NSUInteger _suspendCount;
Availability: Not in OpenStep/MacOS-X
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _taskDescription

@protected NSString* _taskDescription;
Availability: Not in OpenStep/MacOS-X
a description of the current task for diagnostic purposes
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _taskIdentifier

@protected NSUInteger _taskIdentifier;
Availability: Not in OpenStep/MacOS-X
An identifier for this task, assigned by and unique to the owning session
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

### _workQueue

@protected void* _workQueue;
Availability: Not in OpenStep/MacOS-X
The dispatch queue used to handle this request/response. This is actualy a libdispatch queue of type dispatch_queue_t, but on all known implementations this is a pointer, so void* is the correct size.
Warning the underscore at the start of the name of this instance variable indicates that, even though it is not technically private, it is intended for internal use within the package, and you should not use the variable in other code.

# Software documentation for the NSURLSessionUploadTask class

## NSURLSessionUploadTask : NSURLSessionDataTask

> Declared in:
>   Foundation/NSURLSession.h

Availability: Not in OpenStep/MacOS-X
Description forthcoming.

# Software documentation for the NSURLSessionDataDelegate protocol

## NSURLSessionDataDelegate

> Declared in:
>   Foundation/NSURLSession.h

> Conforms to:
>   NSURLSessionTaskDelegate

Availability: Not in OpenStep/MacOS-X
Description forthcoming.
Method summary

- -URLSession:dataTask:didReceiveData:
- -URLSession:dataTask:didReceiveResponse:completionHandler:

### URLSession: dataTask: didReceiveData:

- (void) URLSession: (NSURLSession*)session dataTask: (NSURLSessionDataTask*)dataTask didReceiveData: (NSData*)data;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### URLSession: dataTask: didReceiveResponse: completionHandler:

- (void) URLSession: (NSURLSession*)session dataTask: (NSURLSessionDataTask*)dataTask didReceiveResponse: (NSURLResponse*)response completionHandler: (void(^)(NSURLSessionResponseDisposition disposition))completionHandler;
Availability: Not in OpenStep/MacOS-X
Informs the delegate of a response. This message is sent when all the response headers have arrived, before the body of the response arrives.

# Software documentation for the NSURLSessionDelegate protocol

## NSURLSessionDelegate

> Declared in:
>   Foundation/NSURLSession.h

> Conforms to:
>   NSObject

Availability: Not in OpenStep/MacOS-X
Description forthcoming.
Method summary

- -URLSession:didBecomeInvalidWithError:
- -URLSession:didReceiveChallenge:completionHandler:

### URLSession: didBecomeInvalidWithError:

- (void) URLSession: (NSURLSession*)session didBecomeInvalidWithError: (NSError*)error;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### URLSession: didReceiveChallenge: completionHandler:

- (void) URLSession: (NSURLSession*)session didReceiveChallenge: (NSURLAuthenticationChallenge*)challenge completionHandler: (void(^)(NSURLSessionAuthChallengeDisposition disposition,NSURLCredential*credential))handler;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

# Software documentation for the NSURLSessionDownloadDelegate protocol

## NSURLSessionDownloadDelegate

> Declared in:
>   Foundation/NSURLSession.h

> Conforms to:
>   NSURLSessionTaskDelegate

Availability: Not in OpenStep/MacOS-X
Description forthcoming.
Method summary

- -URLSession:downloadTask:didFinishDownloadingToURL:
- -URLSession:downloadTask:didResumeAtOffset:expectedTotalBytes:
- -URLSession:downloadTask:didWriteData:totalBytesWritten:totalBytesExpectedToWrite:

### URLSession: downloadTask: didFinishDownloadingToURL:

- (void) URLSession: (NSURLSession*)session downloadTask: (NSURLSessionDownloadTask*)downloadTask didFinishDownloadingToURL: (NSURL*)location;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### URLSession: downloadTask: didResumeAtOffset: expectedTotalBytes:

- (void) URLSession: (NSURLSession*)session downloadTask: (NSURLSessionDownloadTask*)downloadTask didResumeAtOffset: (int64_t)fileOffset expectedTotalBytes: (int64_t)expectedTotalBytes;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### URLSession: downloadTask: didWriteData: totalBytesWritten: totalBytesExpectedToWrite:

- (void) URLSession: (NSURLSession*)session downloadTask: (NSURLSessionDownloadTask*)downloadTask didWriteData: (int64_t)bytesWritten totalBytesWritten: (int64_t)totalBytesWritten totalBytesExpectedToWrite: (int64_t)totalBytesExpectedToWrite;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

# Software documentation for the NSURLSessionTaskDelegate protocol

## NSURLSessionTaskDelegate

> Declared in:
>   Foundation/NSURLSession.h

> Conforms to:
>   NSURLSessionDelegate

Availability: Not in OpenStep/MacOS-X
Description forthcoming.
Method summary

- -URLSession:task:didCompleteWithError:
- -URLSession:task:didReceiveChallenge:completionHandler:
- -URLSession:task:didSendBodyData:totalBytesSent:totalBytesExpectedToSend:
- -URLSession:task:willPerformHTTPRedirection:newRequest:completionHandler:

### URLSession: task: didCompleteWithError:

- (void) URLSession: (NSURLSession*)session task: (NSURLSessionTask*)task didCompleteWithError: (NSError*)error;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### URLSession: task: didReceiveChallenge: completionHandler:

- (void) URLSession: (NSURLSession*)session task: (NSURLSessionTask*)task didReceiveChallenge: (NSURLAuthenticationChallenge*)challenge completionHandler: (void(^)(NSURLSessionAuthChallengeDisposition disposition,NSURLCredential*credential))handler;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### URLSession: task: didSendBodyData: totalBytesSent: totalBytesExpectedToSend:

- (void) URLSession: (NSURLSession*)session task: (NSURLSessionTask*)task didSendBodyData: (int64_t)bytesSent totalBytesSent: (int64_t)totalBytesSent totalBytesExpectedToSend: (int64_t)totalBytesExpectedToSend;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### URLSession: task: willPerformHTTPRedirection: newRequest: completionHandler:

- (void) URLSession: (NSURLSession*)session task: (NSURLSessionTask*)task willPerformHTTPRedirection: (NSHTTPURLResponse*)response newRequest: (NSURLRequest*)request completionHandler: (void(^)(NSURLRequest*))completionHandler;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

Up